//
//  mzfabric.h
//  mzfabric
//
//  Created by Breck H. Auten on 8/22/16.
//  Copyright © 2016 Markzware. All rights reserved.
//
#pragma once
#ifndef __mzfabric_h__
#define __mzfabric_h__

#include <stddef.h>

#ifdef __APPLE__

#ifdef __OBJC__
#import <cocoa/cocoa.h>
#endif


void __attribute__((visibility("default"))) 
MzFabInit(const char *theApiKey=NULL, const char *theUserID=NULL);

void __attribute__((visibility("default"))) 
MzFabInit(
          const char *theAPIKey                      /* Get this from Fabric */
          , bool theRegisterCrash                      /* True == Send crash reports */
          , const char *theUserID      = "n/a"         /* Default UserID (e.g. mzCert) */
          , const char *theExtra       = "n/a"         /* Default Info (e.g. signature) */
          , const char *theRootName    = "MZ"          /* Used as part of the event label */
          , const char *theEventLabel  = "Metrics"       /* Shows up in the Answer metrics a custom event */
          , const char *theHostVersion = "n/a"         /* Default One of the custom metrics */
);

#ifdef __OBJC__
void __attribute__((visibility("default"))) 
MzFabSendUsageEx(NSString *theEventName, NSDictionary *theNSDictionary);
#endif

void __attribute__((visibility("default"))) 
MzFabSendUsage(  
               const char *theUserId       = NULL          /* NULL=will use id from MzFabInit*/
               , const char * thePageCount   = "n/a"         /* Number of pages converted */
               , const char * theFileSize    = "n/a"         /* File size of document */
               , const char * theDocVersion  = "n/a"         /* try to be consistant */
               , const char * theExtra       = NULL          /* NULL=will use from QFWInit, extra info (e.g. PRODUCT_SIGNATURE) */
               , const char * theStatus      = "n/a"         /* anything reasonable */
               , const char * theHostVersion = NULL
               );

void __attribute__((visibility("default"))) MzFabLoginEvent(const char *theAPIKey, const char *theUserID, const char *theExtra, int theStatus);


void __attribute__((visibility("default"))) MzFabForceCrash(void);



#endif

#endif


